package com.winsun.controller;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.winsun.auth.core.annotion.Permission;
import com.winsun.auth.core.base.controller.BaseController;
import com.winsun.auth.core.common.model.ResponseData;
import com.winsun.bean.KpiScore;
import com.winsun.mapper.KpiScoreMapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * KPI打分 controller
 * @Author: chenhaojian
 * @Date: 2021/6/3
 */
@Slf4j
@RestController
@RequestMapping("/kpiScore")
public class KpiScoreController extends BaseController {

    @Autowired
    private KpiScoreMapper kpiScoreMapper;

    @Permission(menuname = "查询信息", value = "list", method = RequestMethod.POST)
    public Map<String,Object> dataList(@RequestParam(name = "position",required = false)String position,
                                       @RequestParam(name = "pageNo", required = false) int pageNo,
                                       @RequestParam(name = "pageSize", required = false) int pageSize
    ){
        Map<String,Object> map = new HashMap<>();
        Wrapper<KpiScore> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(position), "position",position);
        List<String> objects = new ArrayList<>();
        objects.add("id");
        wrapper.orderDesc(objects);
        Page<KpiScore> page = new Page<>(pageNo, pageSize);
        List<KpiScore> aPackage = kpiScoreMapper.selectPage(page, wrapper);
        page.setRecords(aPackage);
        map.put("page", ResponseData.success(page,"查询成功！"));
        return map;
    }

    @RequestMapping(value = "addData",method = RequestMethod.POST)
    public ResponseData<String> addData(@RequestParam(name = "position") String position,
                                        @RequestParam(name = "score") String score,
                                        @RequestParam(name = "remarks") String remarks){
        KpiScore kpiScore = new KpiScore();
        kpiScore.setPosition(position);
        kpiScore.setScore(score);
        kpiScore.setRemarks(remarks);
        try {
            kpiScoreMapper.insert(kpiScore);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }

    @RequestMapping(value = "updateData",method = RequestMethod.POST)
    public ResponseData<String> updateData(@RequestParam(name = "id") String id,
                                            @RequestParam(name = "position") String position,
                                            @RequestParam(name = "score") String score,
                                            @RequestParam(name = "remarks") String remarks){
        Wrapper<KpiScore> wrapper = new EntityWrapper<>();
        wrapper.eq("id",id);
        KpiScore kpiScore = new KpiScore();
        kpiScore.setPosition(position);
        kpiScore.setScore(score);
        kpiScore.setRemarks(remarks);
        try {
            kpiScoreMapper.update(kpiScore,wrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }

    @RequestMapping(value = "deleteData",method = RequestMethod.POST)
    public ResponseData<String> deleteData(@RequestParam(name = "id") String id){
        if(StringUtils.isBlank(id)){
            return ResponseData.error("");
        };
        Wrapper<KpiScore> wrapper = new EntityWrapper<>();
        wrapper.eq(StringUtils.isNotBlank(id), "id",id);
        try {
            kpiScoreMapper.delete(wrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ResponseData.success();
    }
}
